var keyboardShortcuts = (function() {

	var isMac = (os.platform() === 'darwin');
	var ctrl = (isMac) ? 'cmd+' : 'ctrl+';


	jwerty.key(ctrl+'shift+S', function() {
		files.saveWmFileAs();
		return false;
	});


	jwerty.key(ctrl+'shift+P/ctrl+space', function() {
		if ($("#command-palette-wrapper").is(":visible")) {
			$("#command-palette-wrapper").remove();
			_editor.focus();
		} else {
			commandPalette.showCommandPalette();
		}
		return false;
	});


	jwerty.key(ctrl+'shift+O', function() {
		if ($("#command-palette-wrapper").is(":visible")) {
			$("#command-palette-wrapper").remove();
			_editor.focus();
		} else {
			commandPalette.showCommandPalette(jumps.getJumpsPaletteItems(), {isRoot: true});
		}
		return false;
	});


	jwerty.key(ctrl+'shift+U', function() {
		if ($("#command-palette-wrapper").is(":visible")) {
			$("#command-palette-wrapper").remove();
			_editor.focus();
		} else {
			commandPalette.showCommandPalette(storage.getDocumentsPaletteItems(), {isRoot: true});
		}
		return false;
	});

	jwerty.key(ctrl+'shift+R', function() {
		if ($("#command-palette-wrapper").is(":visible")) {
			$("#command-palette-wrapper").remove();
			_editor.focus();
		} else {
			commandPalette.showCommandPalette(repository.getRepoPaletteItems(), {isRoot: true});
		}
		return false;
	});


	jwerty.key(ctrl+'shift+I', function() {
		if ($("#command-palette-wrapper").is(":visible")) {
			$("#command-palette-wrapper").remove();
			_editor.focus();
		} else {
			storage.showProjectsPalette();
		}
		return false;
	});


	jwerty.key('esc', function() {
		win.toggleFullscreen();
	});

	jwerty.key('shift+esc', function() {
		wm.toggleDistractionFree();
	});

	jwerty.key(ctrl+'shift+J', function() {
		win.showDevTools();
	});


	// jwerty.key('alt+shift+S', function() {
	// 	wm.rotateSepia();
	// });

	// jwerty.key('alt+shift+B', function() {
	// 	wm.rotateBrightness();
	// });

	jwerty.key(ctrl+'P', function() {
		wm.printText();
	});

	jwerty.key(ctrl+'Q', function() {
		app.closeAllWindows();
	});

	jwerty.key('F12', function() {
		universalPane.togglePanes();
	});

	jwerty.key('F10', function() {
		wm.toggleDocsJumps();
	});

	jwerty.key('F9', function() {
		wm.togglePanes();
	});

	jwerty.key('F1', function() {
		opener("https://github.com/writemonkey/wm3/wiki/Documentation#keyboard-shortcuts");
	});


	//util - always focus editor if not focused
	jwerty.key('tab', function() {
		if (!_editor.hasFocus()) {
			_editor.focus();
			return false; // like preventDefault()!!!!!!!
		}
	});

	// jwerty.key('→/←', function() {
	// 	if (!_editor.hasFocus()) {
	// 		_editor.focus();
	// 		return false; // like preventDefault()!!!!!!!
	// 	}
	// });


	return {

	};

})();