var files = (function() {


	var fileWatcher = null;
	var handleChangeEvent = true;


	function __init() {

	}


	function openWmFileWithDialog() {
		var dir = getLastUsedPath();
		var hiddenInput = $('<input style="display:none;" id="fileDialogOpen" type="file" nwworkingdir="' + dir + '" />');
		$("body").append(hiddenInput);
		hiddenInput.unbind('change');
		
		hiddenInput.change(function(evt) {
			openWmFile($(this).val());
			storeLastUsedPath($(this).val());
			$(this).val('');
		});

		hiddenInput.trigger('click');
	}



	function openWmFile(p, options) {

		storage.newDocument(_currentId, function() {

			var fileO = getWmFile(p);

			_editor.setValue(fileO.text);
			_currentDoc.pth = p;
			_currentDoc = storage.getDocumentObject();

		});
	}


	function saveWmFileAs(options) {
		// files_default_extension
		var dir = getLastUsedPath();
		var name = getFsValidName(_currentDoc.nam);
		var hiddenInput = $('<input style="display:none;" id="fileDialogSaveAs" type="file" nwworkingdir="' + dir +'" nwsaveas="' + name + '" />');
		$("body").append(hiddenInput);
		hiddenInput.unbind('change');
		
		hiddenInput.change(function(evt) {
			_currentDoc.pth = $(this).val();
			storeLastUsedPath($(this).val());
			_editor.execCommand("save");
			$(this).val('');
		});

		hiddenInput.trigger('click');
	}


	function unbindWmFile(id) {
		var modal = new tingle.modal({
			footer: true,
			stickyFooter: false,
			closeMethods: [],
			closeLabel: "",
			// cssClass: ["neki"],
			// onOpen: function () {
			// 	console.log('modal open');
			// },
			// onClose: function () {
			// 	console.log('modal closed');
			// },
			beforeClose: function () {
				return true; // close the modal
				//return false; // nothing happens
			}
		});

		modal.setContent('<strong>Unbinding the file from the document ...</strong><br><br>Do you want to keep the file:<br><br><i>' + _currentDoc.pth + '</i>');
		modal.addFooterBtn('Unbind and keep file', 'tingle-btn', function () {
			// here goes some logic
			_currentDoc.pth = "";
			$("#doc_list").jqxListBox('invalidate');
			_editor.execCommand('save');
			modal.close();
		});
		modal.addFooterBtn('Unbind and delete file', 'tingle-btn', function () {
			// here goes some logic
			if (fs.existsSync(_currentDoc.pth)) {
				fs.unlinkSync(_currentDoc.pth);
				_currentDoc.pth = "";
				$("#doc_list").jqxListBox('invalidate');
				_editor.execCommand('save');
			}
			modal.close();
		});
		modal.addFooterBtn('Cancel', 'tingle-btn', function () {
			// here goes some logic
			modal.close();
		});
		// wm theme styling for modal dialogs - tingle
		$(".tingle-btn").css({
			"background": localStorage["VIEWPORT_MARK_COLOR"],
			"color": localStorage["VIEWPORT_BACKGROUND_COLOR"]
		});
		modal.open();
	}



	function saveWmFile(p, value, options) {
		
		// first rename to bak
		// fs.rename(p, p + ".BAK", function (e) { // rename existing file if exists
		// });

		try {	
			value = manageNewLines(value); // then write new file
			fs.writeFile(p, value, {
				encoding: "utf-8"
			}, function (error) {
				if (error) {
					console.error("Error writing file: " + p, error);
					return;
				}
				console.log('File saved: ' + p);
			});
			
		} catch (e) {
			console.error("Error writing file: " + p, e);
		}
	}


	function getWmFile(p, options) {

		try {
			var stats = fs.statSync(p);
		} catch (e) {
			return null;
		}

		var text = fs.readFileSync(p, { encoding: "utf-8" });
		text = stripBOM(text);
		var hash = getHashFromString(text);
		var stats = stats ? stats : "";

		var fileObject = {
			path: p,
			text: text,
			hash: hash,
			stats: stats
		};
		
		return fileObject;
	}



	function getWmFileInfo(p, options) {
		try {
			return fs.statSync(p)
		} catch (e) {
			return null;
		}
	}

	// not reliable!!!!
	function watchFileForChanges(path) {

		// first disable old watcher if exists
		// if (fileWatcher != null) {
		// 	fileWatcher.close();
		// }
		
		console.log('Setting watcher for: ', path);

		
		fileWatcher = fs.watch(path, function(event, fileName) {

			if(filename){
			    console.log('Event : ' + event);
			    console.log(filename + ' file Changed ...');
			  }
			  else{
			    console.log('filename not provided')
			  }


			// var now = moment();
			// var localM = moment(_currentDoc.dtm);
			// var secDiff = Math.abs(moment.duration(now.diff(localM)).asSeconds());
			// console.log(event, 'diff: ', secDiff);
			

			// if (secDiff > 2 && handleChangeEvent) { // something fishy is going on
			// 	handleChangeEvent = false;
			// 	var dialog = confirm("Changed from outside!");
			// 	if (dialog == true) {
			// 		handleChangeEvent = true;
			// 	} else {
			// 		handleChangeEvent = true;

			// 	}
			// } else { // that was us, no worries

			// }
		});
	}




	function getFsValidName(oldName) {
		oldName = (oldName.length > 30) ? oldName.substring(0, 30) : oldName;
		oldName = oldName.replace(/[\\~#%&*{}/:<>?|".,]+/g, "").trim();
		oldName += "." + _settings.files_default_extension;
		return oldName;
	}

	function storeLastUsedPath(p) {
		localStorage["STORAGE_FILES_LAST_PATH"] = path.dirname(p);
	}

	function getLastUsedPath() {
		return localStorage["STORAGE_FILES_LAST_PATH"] ? localStorage["STORAGE_FILES_LAST_PATH"] : process.env[(process.platform == 'win32') ? 'USERPROFILE' : 'HOME'];
	}

	function openFileFolder() {
		if (_currentDoc.pth.length > 0) {
			opener(path.dirname(_currentDoc.pth));
			// child.exec('start "" "' + path.dirname(_currentDoc.pth) + '"');
		}
	}


	function getHashFromString(str) {
		return crp.createHash('sha256').update(normalizeNewLines(str)).digest("hex");
	}


	function normalizeNewLines(str) {
		return str.replace(/\r\n/g, '\n');
	}

	function manageNewLines(str) {
		if (os.platform() == 'win32' && _settings["files_force_CRLF_line_breaks_on_windows"]) { 
			return str.replace(/\n/g, '\r\n');
		}
		return str;
	}

	function stripBOM(str) {
		return (str.charCodeAt(0) === 0xFEFF) ? str.slice(1) : str;
	}




	function copyFile(source, target) {
	    return new Promise(function(resolve, reject) {
	        var rd = fs.createReadStream(source);
	        rd.on('error', rejectCleanup);
	        var wr = fs.createWriteStream(target);
	        wr.on('error', rejectCleanup);
	        function rejectCleanup(err) {
	            rd.destroy();
	            wr.end();
	            reject(err);
	        }
	        wr.on('finish', resolve);
	        rd.pipe(wr);
	    });
	}



	// Call constructor
	__init();
	

	return {
		openWmFile : openWmFile,
		saveWmFile: saveWmFile,
		saveWmFileAs: saveWmFileAs,
		unbindWmFile: unbindWmFile,
		getLastUsedPath: getLastUsedPath,
		getWmFile: getWmFile,
		getWmFileInfo: getWmFileInfo,
		openWmFileWithDialog: openWmFileWithDialog,
		openFileFolder: openFileFolder,
		getHashFromString: getHashFromString,
		normalizeNewLines: normalizeNewLines,
		watchFileForChanges: watchFileForChanges,
		copyFile: copyFile
	};

})(window);