var menus = (function() {

	


	var mainContextMenu = new gui.Menu({
		'type': 'menubar'
	});

	mainContextMenu.append(new gui.MenuItem({
		label: 'New document',
		click: function() {
			_editor.execCommand("newDocument");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'New project',
		click: function() {
			storage.newProject();
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Command Palette',
		click: function() {
			commandPalette.showCommandPalette();
		}
	}));


	mainContextMenu.append(new gui.MenuItem({
		label: 'Toggle full screen',
		click: function() {
			win.toggleFullscreen();
		}
	}));


	// mainContextMenu.append(new gui.MenuItem({
	// 	label: 'Toggle distraction free',
	// 	click: function() {
	// 		wm.toggleDistractionFree();
	// 	}
	// }));

	mainContextMenu.append(new gui.MenuItem({
		type: 'separator'
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Toggle fold all headings',
		click: function() {
			_editor.execCommand("toggleFoldAll");
		}
	}));


	mainContextMenu.append(new gui.MenuItem({
		label: 'Toggle collapsed region',
		click: function() {
			_editor.execCommand("collapseSelection");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Toggle focus',
		click: function() {
			_editor.execCommand("toggleFocus");
		}
	}));


	mainContextMenu.append(new gui.MenuItem({
		type: 'separator'
	}));


	mainContextMenu.append(new gui.MenuItem({
		label: 'Cut',
		click: function() {
			_editor.execCommand("cut");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Copy',
		click: function() {
			_editor.execCommand("copy");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Copy all',
		click: function() {
			_editor.execCommand("copyAll");
		}
	}));

	
	mainContextMenu.append(new gui.MenuItem({
		label: 'Paste',
		click: function() {
			_editor.execCommand("paste");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Paste collapsed',
		click: function() {
			_editor.execCommand("pasteAndCollapse");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Move to repository',
		click: function() {
			_editor.execCommand("moveToRepository");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Copy to repository',
		click: function() {
			_editor.execCommand("copyToRepository");
		}
	}));

	

	mainContextMenu.append(new gui.MenuItem({
		label: 'Search with Google',
		click: function() {
			_editor.execCommand("searchWithGoogle");
		}
	}));

	

	mainContextMenu.append(new gui.MenuItem({
		type: 'separator'
	}));

	
	mainContextMenu.append(new gui.MenuItem({
		label: 'Dev tools',
		click: function() {
			win.showDevTools();
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Report bug / issue',
		click: function() {
			opener("https://github.com/writemonkey/wm3/issues");
		}
	}));

	mainContextMenu.append(new gui.MenuItem({
		label: 'Quit',
		click: function() {
			app.closeAllWindows();
		}
	}));



	function getJumpTileMenu(item, mx, my) {


		var m = new gui.Menu({
			'type': 'menubar'
		});

		m.append(new gui.MenuItem({
			label: 'Update',
			click: function() {
				jumps.updateListBox();
			}
		}));

		m.append(new gui.MenuItem({
			label: 'Show all',
			click: function() {
				localStorage["JUMPS_SHOW_HEADINGS"] = "1";
				localStorage["JUMPS_SHOW_COMMENTS"] = "1";
				localStorage["JUMPS_SHOW_BOOKMARKS"] = "1";
				localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] = "1";
				localStorage["JUMPS_SHOW_TASKS"] = "1";
				localStorage["JUMPS_SHOW_DELETES"] = "1";
				localStorage["JUMPS_SHOW_MARKED_TEXT"] = "1";
				localStorage["JUMPS_SHOW_IMAGES"] = "1";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);

			}
		}));

		m.append(new gui.MenuItem({
			label: 'Clear all',
			click: function() {
				localStorage["JUMPS_SHOW_HEADINGS"] = "0";
				localStorage["JUMPS_SHOW_COMMENTS"] = "0";
				localStorage["JUMPS_SHOW_BOOKMARKS"] = "0";
				localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] = "0";
				localStorage["JUMPS_SHOW_TASKS"] = "0";
				localStorage["JUMPS_SHOW_DELETES"] = "0";
				localStorage["JUMPS_SHOW_MARKED_TEXT"] = "0";
				localStorage["JUMPS_SHOW_IMAGES"] = "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);

			}
		}));


		m.append(new gui.MenuItem({
			type: 'separator'
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_HEADINGS"] || localStorage["JUMPS_SHOW_HEADINGS"] == "1",
			label: 'Headings',
			click: function() {
				localStorage["JUMPS_SHOW_HEADINGS"] = localStorage["JUMPS_SHOW_HEADINGS"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_COMMENTS"] || localStorage["JUMPS_SHOW_COMMENTS"] == "1",
			label: 'Comments',
			click: function() {
				localStorage["JUMPS_SHOW_COMMENTS"] = localStorage["JUMPS_SHOW_COMMENTS"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_BOOKMARKS"] || localStorage["JUMPS_SHOW_BOOKMARKS"] == "1",
			label: 'Bookmarks',
			click: function() {
				localStorage["JUMPS_SHOW_BOOKMARKS"] = localStorage["JUMPS_SHOW_BOOKMARKS"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] || localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] == "1",
			label: 'Footnotes',
			click: function() {
				localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] = localStorage["JUMPS_SHOW_TASK_FOOTNOTES"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_TASKS"] || localStorage["JUMPS_SHOW_TASKS"] == "1",
			label: 'Tasks',
			click: function() {
				localStorage["JUMPS_SHOW_TASKS"] = localStorage["JUMPS_SHOW_TASKS"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));


		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_DELETES"] || localStorage["JUMPS_SHOW_DELETES"] == "1",
			label: 'Deletes',
			click: function() {
				localStorage["JUMPS_SHOW_DELETES"] = localStorage["JUMPS_SHOW_DELETES"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_MARKED_TEXT"] || localStorage["JUMPS_SHOW_MARKED_TEXT"] == "1",
			label: 'Marked text',
			click: function() {
				localStorage["JUMPS_SHOW_MARKED_TEXT"] = localStorage["JUMPS_SHOW_MARKED_TEXT"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: !localStorage["JUMPS_SHOW_IMAGES"] || localStorage["JUMPS_SHOW_IMAGES"] == "1",
			label: 'Images',
			click: function() {
				localStorage["JUMPS_SHOW_IMAGES"] = localStorage["JUMPS_SHOW_IMAGES"] == "0" ?  "1" : "0";
				jumps.updateListBox();
				getJumpTileMenu(0, mx, my).popup(mx, my);
			}
		}));

		return m;
	}

	

	function getDocumentTileMenu(item) {

		var id = item.replace("document-tile-", "");
		var isFileBind = $.contains( $("#" + item).get(0),  $("#file-bind-" + id).get(0));
		var isFavourite = $.contains( $("#" + item).get(0),  $("#is-fav-" + id).get(0));
		var isLocked = $.contains($("#" + item).get(0), $("#is-readonly-" + id).get(0));

		
		var documentObject = JSON.parse($("#doc_list").jqxListBox('getSelectedItem').value);
		var isScrap = documentObject.rep;
		var isDeleted = documentObject.del;


		var m = new gui.Menu({
			'type': 'menubar'
		});

		m.append(new gui.MenuItem({
			label: 'Show compact document list',
			type: 'checkbox',
			checked: localStorage["VIEWPORT_DOCUMENT_PANE_COMPACT"] == "1" ? true : false,
			click: function() {
				localStorage["VIEWPORT_DOCUMENT_PANE_COMPACT"] = localStorage["VIEWPORT_DOCUMENT_PANE_COMPACT"] == 1 ? 0 : 1;
				$("#doc_list").jqxListBox('invalidate');
			}
		}));

		m.append(new gui.MenuItem({
			type: 'separator'
		}));

		if (isFileBind) {
			m.append(new gui.MenuItem({
				label: 'Unbind saved file',
				click: function() {
					files.unbindWmFile(id)
				}
			}));

			m.append(new gui.MenuItem({
				label: 'Reveal file in directory',
				click: function() {
					files.openFileFolder();
				}
			}));
		} else {
			m.append(new gui.MenuItem({
				label: 'Save as file & bind to document',
				click: function() {
					files.saveWmFileAs();
				}
			}));
		}

		m.append(new gui.MenuItem({
			label: 'New document',
			click: function() {
				storage.newDocument(id);
			}
		}));

		m.append(new gui.MenuItem({
			label: 'New project',
			click: function() {
				storage.newProject();
			}
		}));

		m.append(new gui.MenuItem({
			label: 'Open file',
			click: function() {
				files.openWmFileWithDialog();
			}
		}));


		m.append(new gui.MenuItem({
			type: 'separator'
		}));

		
		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: isFavourite,
			label: 'Mark as favourite',
			click: function() {
				_currentDoc.fav = !isFavourite;
				
				$("#doc_list").jqxListBox('updateAt', {
					label: $("#doc_list").jqxListBox('getSelectedItem').label,
					value: JSON.stringify(_currentDoc)
				}, $("#doc_list").jqxListBox('getSelectedIndex'));

				$("#doc_list").jqxListBox('invalidate');
				
				storage.updateFields(_currentDoc._id, {
					fav: !isFavourite
				});
			}
		}));


		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: isScrap,
			label: 'Mark as scrap',
			click: function() {
				_currentDoc.rep = !isScrap;

				$("#doc_list").jqxListBox('updateAt', {
					label: $("#doc_list").jqxListBox('getSelectedItem').label,
					value: JSON.stringify(_currentDoc)
				}, $("#doc_list").jqxListBox('getSelectedIndex'));

				$("#doc_list").jqxListBox('invalidate');
				
				storage.updateFields(_currentDoc._id, {
					rep: !isScrap
				});
			}
		}));


		m.append(new gui.MenuItem({
			type: 'checkbox',
			checked: isLocked,
			label: 'Mark as read only',
			click: function () {
				_currentDoc.lck = !isLocked;

				$("#doc_list").jqxListBox('updateAt', {
					label: $("#doc_list").jqxListBox('getSelectedItem').label,
					value: JSON.stringify(_currentDoc)
				}, $("#doc_list").jqxListBox('getSelectedIndex'));

				$("#doc_list").jqxListBox('invalidate');

				if (isLocked) {
					_editor.disableReadOnly();
				} else {
					_editor.enableReadOnly();
				}
				storage.uiUpdateDocumentName(storage.getDocumentName());
				storage.updateFields(_currentDoc._id, {
					lck: !isLocked
				});
			}
		}));


		

		m.append(new gui.MenuItem({
			type: 'separator'
		}));


		if (!isDeleted) {
			m.append(new gui.MenuItem({
				label: 'Move to trash',
				click: function () {
					storage.deleteDocument(id);
				}
			}));
		} else {
			m.append(new gui.MenuItem({
				label: 'Restore deleted document',
				click: function () {
					storage.unDeleteDocument(id);
				}
			}));
		}

		

		return m;
	}





	function getProjectTileMenu(itemId) {


		if (itemId == "p8") {
			return getLastSearchMenu();
		}



		var m = new gui.Menu({
			'type': 'menubar'
		});

		if (itemId == "p5") { // Trash
			m.append(new gui.MenuItem({
				label: 'Empty trash',
				click: function() {
					storage.emptyTrash();
				}
			}));
			return m;
		}

		if (itemId == "p4") { // Last opened
			m.append(new gui.MenuItem({
				label: 'Empty last opened list',
				click: function() {
					localStorage['DOCUMENTS_RECENT_DOCS'] = "";
					$('#sources_list').jqxTree('selectItem', $('#sources_list li')[1]); // select All documents
					wm.showNotice('<strong>Last opened list is empty.</strong>', {
						autoClose: true
					});
					// storage.setDocumentList({
					// 	del: false,
					// 	_id: {$in: JSON.parse(localStorage['DOCUMENTS_RECENT_DOCS'])}
					// }, {});
				}
			}));
			return m;
		}

		
		if (itemId == "pb6") {
			m.append(new gui.MenuItem({
				label: 'New project',
				click: function() {
					storage.newProject();
				}
			}));
		}

		


		if (itemId != "pb6") {

			m.append(new gui.MenuItem({
				label: _settings.allow_subprojects == true ? 'New subproject' : 'New project',
				click: function() {
					storage.newProject(itemId);
				}
			}));



			m.append(new gui.MenuItem({
				type: 'separator'
			}));

			m.append(new gui.MenuItem({
				label: 'Move to top of the list',
				click: function() {
					storage.moveProjectToTop(itemId);
				}
			}));

			m.append(new gui.MenuItem({
				label: 'Rename project',
				click: function() {
					storage.renameProject(itemId);
				}
			}));

			m.append(new gui.MenuItem({
				label: 'Copy project as text',
				click: function() {
					storage.copyProjectTxt(itemId);
				}
			}));

			m.append(new gui.MenuItem({
				label: 'Count words',
				click: function () {
					wm.showProjectWordCount();
				}
			}));

			m.append(new gui.MenuItem({
				label: 'Delete project',
				click: function() {
					storage.deleteProject(itemId);
				}
			}));
		}

		


		return m;
	}

	

	function getLastSearchMenu() {
		
		var m = new gui.Menu({
			'type': 'menubar'
		});

		
		if ($('#doc_search_input').val() != "") {
			
			m.append(new gui.MenuItem({
				label: 'Clear search',
				click: function() {
					$('#doc_search_input').val("");
					storage.doFullTextSearch("");
				}
			}));

			m.append(new gui.MenuItem({
				type: 'separator'
			}));
		}
		


		var arr = storage.getLastSearchesArray();

		for (var i = 0; i < arr.length; i++) {

			m.append(new gui.MenuItem({
				label: arr[i],
				click: function() {
					$('#doc_search_input').val(this.label);
					$('#doc_search_input').focus();

					storage.doFullTextSearch(this.label);
				}
			}));
		}

		return m;
	}


	function getInfobarStatsMenu() {
		
		var m = new gui.Menu({
			'type': 'menubar'
		});

		var ibchoices = ["getWords", "getCharactersWS", "getCharactersWOS", "getSentences", "getParagraphs", "getPages", "getReadingTime", "getSpeakingTime"];
		var statsFunctions = ibchoices.map(function(u){return stats[u]});


		for (var i = 0; i < ibchoices.length; i++) {

			var stat = statsFunctions[i](_editor.somethingSelected() ? _editor.getSelection() : _editor.getValue());
			
			m.append(new gui.MenuItem({
				type: 'checkbox',
				enabled: true,
				checked: localStorage["STAT_IN_INFOBAR"] && localStorage["STAT_IN_INFOBAR"] == ibchoices[i],
				label: stats.add000separator(stat.count) + '  ·  ' + stat.unit,
				tooltip: ibchoices[i],
				click: function() {
					localStorage["STAT_IN_INFOBAR"] = this.tooltip;
					wm.messageToStatsWorker({update: true, units: ['getWords', this.tooltip]});
				}
			}));
		}		

		return m;
	}

	


	function registerMenuItem() {

	}


	function composeContextMenu() {

	}



	/*
	########   ##     ##  ########   ##    ##   ########    ######    
	##         ##     ##  ##         ###   ##      ##      ##    ##   
	##         ##     ##  ##         ####  ##      ##      ##         
	######     ##     ##  ######     ## ## ##      ##       ######    
	##          ##   ##   ##         ##  ####      ##            ##   
	##           ## ##    ##         ##   ###      ##      ##    ##   
	########      ###     ########   ##    ##      ##       ######    
	*/

	$("#grid").on("contextmenu", function(e) {
		var token = _editor.getTokenAt(_editor.getCursor());
		if (token.type && token.type.indexOf("spell-error") > -1)
			return;

		mainContextMenu.popup(e.originalEvent.x, e.originalEvent.y);
	});
	


	/*
	   ###     ########   ####  
	  ## ##    ##     ##   ##   
	 ##   ##   ##     ##   ##   
	##     ##  ########    ##   
	#########  ##          ##   
	##     ##  ##          ##   
	##     ##  ##         ####  
	*/
	return {
		getDocumentTileMenu: getDocumentTileMenu,
		getJumpTileMenu: getJumpTileMenu,
		getProjectTileMenu: getProjectTileMenu,
		getLastSearchMenu: getLastSearchMenu,
		getInfobarStatsMenu: getInfobarStatsMenu
		
	};

})();