// import stats object
importScripts("modules/stats/stats.js");

// thread globals
var countInterval = 1000;

var units = [];

var countTimer = setInterval(doCount, countInterval);
var editorText = "";


var lastCharCount = 0;
var lastWordCount = 0;
var lastProcessedCharCount = 1;
var lastProgressObject = {};
var lastMessageString = "";




/*
 ######     #######   ##     ##  ##    ##   ########   
##    ##   ##     ##  ##     ##  ###   ##      ##      
##         ##     ##  ##     ##  ####  ##      ##      
##         ##     ##  ##     ##  ## ## ##      ##      
##         ##     ##  ##     ##  ##  ####      ##      
##    ##   ##     ##  ##     ##  ##   ###      ##      
 ######     #######    #######   ##    ##      ##      
*/
function doCount() {



	var t0 = performance.now();
	var statsFunctions = units.map(function(u){return stats[u]});


	// counting not necessary, return last used string
	if (lastCharCount == lastProcessedCharCount) {
		postMessage({prgString: lastMessageString, words: lastWordCount, chars: lastCharCount});
	} 
	// or perform actual count
	else {
		var counting = editorText.length;
		var progressString = "";
		var max = statsFunctions.length;


		for (var i = 0; i < max; i++) {
			var co = statsFunctions[i](editorText); // actual count!!!!
			var dot = (i != max - 1) ? "|" : "";
			if (co.unit == "words") lastWordCount = co.count; // set word count

			progressString += stats.add000separator(co.count) + " " + co.label;
			progressString += (i < statsFunctions.length - 1) ? "&nbsp;&nbsp;" + dot + "&nbsp;&nbsp;" : "";
		}

		// hack to hide words if smth other is selected
		if (max > 1) {
			progressString = progressString.replace(/^.+\|\s*/, '');
		} 

		
		lastMessageString = progressString;
		lastProcessedCharCount = counting;
		

		postMessage({prgString: progressString, words: lastWordCount, chars: lastCharCount});
	}


	var t1 = performance.now();
	//console.log("Stats took: " + (t1 - t0) + " ms");
}


// listen for new text from main thread
onmessage = function(e) {

	// if forced update is required
	if (e.data.update && e.data.update == true) {
		lastProcessedCharCount = 1;
		units = e.data.units;
	} else {
		// get text from main thread and update local editorText value
		editorText = e.data.text;
		lastCharCount = e.data.text.length;
		units = e.data.units;
		sessionStartCount = e.data.sessionStartCount;

		stats.setReadingTime(e.data.readingWPM);
		stats.setSpeakingTime(e.data.speakingWPM);
		stats.setStandardPages(e.data.standard_pages);
	}
};