/*
 ######    ########      ###     ########   ####   ######    
##    ##      ##        ## ##       ##       ##   ##    ##   
##            ##       ##   ##      ##       ##   ##         
 ######       ##      ##     ##     ##       ##   ##         
      ##      ##      #########     ##       ##   ##         
##    ##      ##      ##     ##     ##       ##   ##    ##   
 ######       ##      ##     ##     ##      ####   ######    
*/


/*
Escape regex chars
*/
function escapeRegExp(string){
  return string.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
}


/*
Will return unique id based on the number 
of milliseconds since 1970/01/01
*/
function getNewUniqueID() {
	return (new Date().getTime()).toString();
}


/*
Will create simple hash/checksum. For testing string uniqueness
*/
function getHash(s) {
	return s.split("").reduce(function(a, b) {
		a = ((a << 5) - a) + b.charCodeAt(0);
		return a & a
	}, 0);
}

/*
Will return ago string
*/
function getWidthInPercent(jqitem) {
	return jqitem.width() / jqitem.parent().width() * 100;
}


function isValidColor(stringToTest) {
    //Alter the following conditions according to your need.
    if (stringToTest === "") { return false; }
    if (stringToTest === "inherit") { return false; }
    if (stringToTest === "transparent") { return false; }
    
    var image = document.createElement("img");
    image.style.color = "rgb(0, 0, 0)";
    image.style.color = stringToTest;
    if (image.style.color !== "rgb(0, 0, 0)") { return true; }
    image.style.color = "rgb(255, 255, 255)";
    image.style.color = stringToTest;
    return image.style.color !== "rgb(255, 255, 255)";
}

//SET CURSOR POSITION
$.fn.setCursorPosition = function(pos) {
  this.each(function(index, elem) {
    if (elem.setSelectionRange) {
      elem.setSelectionRange(pos, pos);
    } else if (elem.createTextRange) {
      var range = elem.createTextRange();
      range.collapse(true);
      range.moveEnd('character', pos);
      range.moveStart('character', pos);
      range.select();
    }
  });
  return this;
};


function mapNumberToRange(num, originalRange, targetRange) {
  var nnum = (num - originalRange[0]) * (targetRange[1] - targetRange[0]) / (originalRange[1] - originalRange[0]) + targetRange[0];
  return Math.round(nnum);
}


// get link or return -1 if not md image
function getImageSecFromMd(lineText) {
  var m = lineText.match(/^!\[.*?\]\((.*?)\)/);
  return m && m[1] ? m[1].replace(/\\/g, "/") : -1;
}
//get table or return -1 if not md table
function getMdTable(str) {
  // var m = str.match(//);
  // var m = str.match(/((\|[^|\r\n]*)+\|(\r?\n|\r)?)+/);
  var m = str.match(/^\s*\|.+\|\s*$/gm);
  return m ? str.trim() : -1;
} 

//get math or return -1 if not tath notation
function getKatex(str) {
  var m = str.match(/^\${2,3}.+\${2,3}$/); // |^\\\[.+\\\]$|^\\\(.+\\\)$
  return m ? str.trim() : -1;
}

//get comment or return -1 if not tath notation
function getComment(str) {
  var m = str.match(/^\/\/.+/);
  return m ? str.replace(/^\/\/\s*/, '').replace(/\/\/\s*$/, '').trim() : -1;
}

/*
########   ########    #######   ########    #######   
##     ##  ##     ##  ##     ##     ##      ##     ##  
##     ##  ##     ##  ##     ##     ##      ##     ##  
########   ########   ##     ##     ##      ##     ##  
##         ##   ##    ##     ##     ##      ##     ##  
##         ##    ##   ##     ##     ##      ##     ##  
##         ##     ##   #######      ##       #######   
*/

// Returns new array with unique valus sorted by frequencies
Array.prototype.distinctByCount = function() {
  var itm, a = [],
    L = this.length,
    o = {};
  for (var i = 0; i < L; i++) {
    itm = this[i];
    if (!itm) continue;
    if (o[itm] == undefined) o[itm] = 1;
    else ++o[itm];
  }
  for (var p in o) a[a.length] = p;
  return a.sort(function(a, b) {
    return o[b] - o[a];
  });
};

